// pages/group-details/group-details.js
import httpRequestApi from '../../../utils/APIClient';
import util from '../../../utils/util';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    titleIcon: '',
    title: '',
    bookInfo: '',
    lessonList: [],
    surplusNum: '',
    joinUserList: [],
    surplusList: [],
    timeList: [],
    productId: '',
    groupId: '',
    orderId: '',
    typeOf:'',
    title: '',
    headTextOne: '',
    headTextTwo: '',
    content: [],
  },
  //跳转到年级
  gradeDetails: function () {
    // wx.navigateTo({
    //   url: '/pages/groupPage/grade-details/grade-details'
    // })
    // wx.setNavigationBarTitle({
    //   title: '限量优惠团购'
    // })
  
  },
  //开团
  openGroup: function () {
    const productId = this.data.productId;
    const groupId = this.data.groupId;
    //开始发起团购
    httpRequestApi.SendGroupPurchas({
      productId,
      groupId
    }).success( (res) =>{
      console.log('发起团购',res);
      if(res.data.message) {
        wx.showModal({
          title: '提示',
          content: res.data.message,
          success (res) {
            if (res.confirm) {
              console.log('用户点击确定')
            } else if (res.cancel) {
              console.log('用户点击取消')
            }
          }
        })
        return false;
      }
      if(res.data.data.groupPurchaseOrder.groupType === 'BASE') {
        //掉起支付
        this.prePayMap(res.data.data.prePayMap, res.data.data.groupPurchaseOrderDetail.orderId);
      }

    }).fail( (error) => {
      
    })
  },
  //参团
  jionGroup: function () {
    const orderId = this.data.orderId;
    //开始发起团购
    httpRequestApi.JoinGroupPurchas(orderId).success( (res) =>{
      console.log('参加团购',res);
      if(res.data.message) {
        wx.showModal({
          title: '提示',
          content: res.data.message,
          success (res) {
            if (res.confirm) {
              console.log('用户点击确定')
            } else if (res.cancel) {
              console.log('用户点击取消')
            }
          }
        })
        return false;
      }  
      //掉起支付
      this.prePayMap(res.data.data.prePayMap, res.data.data.orderId, res.data.data.groupPurchaseOrder.id);
    }).fail( (error) => {
      
    })
  },

  //支付
  prePayMap: function (prePayMap, orderId, detailId) {
    console.log(prePayMap)
    const that = this;
    wx.requestPayment(
      {
        'appId': prePayMap.appId,
        'timeStamp': prePayMap.timeStamp,
        'nonceStr': prePayMap.nonceStr,
        'package': prePayMap.package,
        'signType': 'MD5',
        'paySign': prePayMap.sign,
        'success':function(res){
          console.log('支付成功')
          wx.showModal({
            title: '提示',
            content: '支付成功',
            success (res) {
              //获取拼团信息
              setTimeout( () => {
                that.jionSuccess(that.data.orderId);
                that.groupSuccess(orderId, detailId);
              },2000)
            }
          })

        },
        'fail':function(res){
          console.log('支付失败', res)
        }
      })
  },
  //跳转到拼团详情
  collage: function () {

  },
  //拼团详情
  jionSuccess: function (orderId) {
    httpRequestApi.getMygroupInfo(orderId).success( res => {
      console.log('拼团详情', res.data.data);
      const surplusNum = res.data.data.groupPurchaseOrder.headcount - res.data.data.groupPurchaseOrder.joinCount;
      for(var i = 0; i < surplusNum; i++) {
        this.data.surplusList.push(1);
      }
      console.log(res.data.data.groupPurchaseOrder.closeTime - res.data.data.groupPurchaseOrder.gmtModified)
      //时间转换
      const timeList = util.formatTime(res.data.data.groupPurchaseOrder.closeTime - res.data.data.groupPurchaseOrder.gmtModified);
      this.setData({
        surplusNum,
        joinUserList: res.data.data.joinUserList,
        surplusList: this.data.surplusList,
        timeList,
      })
    }).fail( error => {
      console.log('错误', error)
    })    
  },

  //拼团是否成功并弹窗
  groupSuccess: function (orderId, detailId) {
    httpRequestApi.groupSuccess(orderId).success( res => {
      console.log('团购是否成功',res.data.data)
      const status = res.data.data.status;
      debugger;
      const uid = res.data.data.uid;
      if(status == 'successed') {
        if(wx.getStorageSync(uid) == uid) {
          this.setData({
            typeOf: 'success',
            title: '恭喜 !',
            headTextOne: '您发起的团购拼团成功',
            content: [
              {
                  text: "领袖体质魅力无穷！",
                  color: "#000"
              },
              {
                  text: " 您可以继续发起新的团购，",
                  color: "#000"
              },
              {
                text: " 不再需要支付本课程费用，拼团成功，",
                color: "#FF9B00"
              },                          
              {
                  text: " 您将得到xxx元奖励。",
                  color: "#FF0000"
              }
            ],
          })
        }else {
          this.setData({
            typeOf: 'success',
            title: '拼团成功 ! ',
            headTextOne: '您参与的团购拼团成功',
            headTextTwo: '订单号：12344',
            content: [
              {
                  text: "感谢团长的分享",
                  color: "#000"
              },
              {
                  text: " 您也可以发起新的团购分享给需要的朋友们，",
                  color: "#000"
              },
              {
                  text: "作为新的发起人，您无需在支付本课程费用；",
                  color: "#FF0000"
              },
              {
                text: "团购成功，您将得到xxx元奖励。",
                color: "#FF0000"
              }                          
            ],
          })
        }
      }else {
        setTimeout(() => {
          wx.navigateTo({
            url: `/pages/groupPage/collage-details/collage-details?orderId=${detailId}`
          })
          wx.setNavigationBarTitle({
            title: '拼团详情'
          })
        }, 1000)
      }
    }).fail( error => {
      console.log('错误', eroor)
    })    
  },
  //再次发起团
  group: function () {
    wx.showModal({
      title: '提示',
      content: '再次发起团',
      success (res) {
        if (res.confirm) {
          console.log('用户点击确定')
        } else if (res.cancel) {
          console.log('用户点击取消')
        }
      }
    })
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    debugger
    wx.setNavigationBarTitle({
      title: '拼团详情'
    })
    if(!options.productId) return false;
    const productId = options.productId;
    const groupId = options.groupId;
    const orderId = options.id;
    this.setData({
      productId,
      groupId,
      orderId
    })
    //课本详情
    httpRequestApi.getBookDetail(wx.getStorageSync('uid'), productId).success( (res) =>{
      console.log('课本详情',res.data.data);
      const bookInfo = res.data.data.product;
      const lessonList = res.data.data.lessonList;
      this.setData({
          titleIcon: bookInfo.bgImg,
          title: bookInfo.title,
          bookInfo: bookInfo.description
      })
      const lessonTemp = [];
      lessonList.forEach(item => {
          const temp = {};
          temp.id = item.id;
          temp.title = item.title;
          temp.readNum = item.readCount;
          lessonTemp.push(temp);
      });
      this.setData({
          lessonList: lessonTemp
      });
    }).fail( (error) => {

    })
    //获取拼团信息
    this.jionSuccess(orderId);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})